OSDN Git Service

Fix JNI GetDirectBufferAddress.
[android-x86/dalvik.git] / tests / run-test
1 #!/bin/bash
2 #
3 # Copyright (C) 2007 The Android Open Source Project
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 # Set up prog to be the path of this script, including following symlinks,
18 # and set up progdir to be the fully-qualified pathname of its directory.
19 prog="$0"
20 while [ -h "${prog}" ]; do
21     newProg=`/bin/ls -ld "${prog}"`
22     newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23     if expr "x${newProg}" : 'x/' >/dev/null; then
24         prog="${newProg}"
25     else
26         progdir=`dirname "${prog}"`
27         prog="${progdir}/${newProg}"
28     fi
29 done
30 oldwd=`pwd`
31 progdir=`dirname "${prog}"`
32 cd "${progdir}"
33 progdir=`pwd`
34 prog="${progdir}"/`basename "${prog}"`
35
36 export JAVA="java"
37 export JAVAC="javac -target 1.5"
38 export RUN="${progdir}/etc/push-and-run-test-jar"
39
40 info="info.txt"
41 build="build"
42 run="run"
43 expected="expected.txt"
44 output="output.txt"
45 build_output="build-output.txt"
46 run_args="--quiet"
47
48 dev_mode="no"
49 update_mode="no"
50 debug_mode="no"
51 usage="no"
52
53 while true; do
54     if [ "x$1" = "x--local" ]; then
55         RUN="${progdir}/etc/local-run-test-jar"
56         shift
57     elif [ "x$1" = "x--reference" ]; then
58         RUN="${progdir}/etc/reference-run-test-classes"
59         shift
60     elif [ "x$1" = "x--fast" ]; then
61         run_args="${run_args} --fast"
62         shift
63     elif [ "x$1" = "x--portable" ]; then
64         run_args="${run_args} --portable"
65         shift
66     elif [ "x$1" = "x--debug" ]; then
67         run_args="${run_args} --debug"
68         shift
69     elif [ "x$1" = "x--gdb" ]; then
70         run_args="${run_args} --gdb"
71         dev_mode="yes"
72         shift
73     elif [ "x$1" = "x--zygote" ]; then
74         run_args="${run_args} --zygote"
75         shift
76     elif [ "x$1" = "x--no-verify" ]; then
77         run_args="${run_args} --no-verify"
78         shift
79     elif [ "x$1" = "x--no-optimize" ]; then
80         run_args="${run_args} --no-optimize"
81         shift
82     elif [ "x$1" = "x--valgrind" ]; then
83         run_args="${run_args} --valgrind"
84         shift
85     elif [ "x$1" = "x--dev" ]; then
86         run_args="${run_args} --dev"
87         dev_mode="yes"
88         shift
89     elif [ "x$1" = "x--update" ]; then
90         update_mode="yes"
91         shift
92     elif [ "x$1" = "x--help" ]; then
93         usage="yes"
94         shift
95     elif expr "x$1" : "x--" >/dev/null 2>&1; then
96         echo "unknown option: $1" 1>&2
97         usage="yes"
98         break
99     else
100         break
101     fi
102 done
103
104 if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
105     echo "--dev and --update are mutually exclusive" 1>&2
106     usage="yes"
107 fi
108
109 if [ "$usage" = "no" ]; then
110     if [ "x$1" = "x" -o "x$1" = "x-" ]; then
111         test_dir=`basename "$oldwd"`
112     else
113         test_dir="$1"
114     fi
115
116     if [ '!' -d "$test_dir" ]; then
117         td2=`echo ${test_dir}-*`
118         if [ '!' -d "$td2" ]; then
119             echo "${test_dir}: no such test directory" 1>&2
120             usage="yes"
121         fi
122         test_dir="$td2"
123     fi
124
125     # Shift to get rid of the test name argument. The rest of the arguments
126     # will get passed to the test run.
127     shift
128 fi
129
130 if [ "$usage" = "yes" ]; then
131     prog=`basename $prog`
132     (
133         echo "usage:"
134         echo "  $prog --help                          Print this message."
135         echo "  $prog [options] [test-name]           Run test normally."
136         echo "  $prog --dev [options] [test-name]     Development mode" \
137             "(dumps to stdout)."
138         echo "  $prog --update [options] [test-name]  Update mode" \
139             "(replaces expected.txt)."
140         echo '  Omitting the test name or specifying "-" will use the' \
141             "current directory."
142         echo "  Runtime Options:"
143         echo "    --fast         Use the fast interpreter (the default)."
144         echo "    --portable     Use the portable interpreter."
145         echo "    --debug        Wait for a debugger to attach."
146         #echo "    --gdb          Run under gdb; incompatible with some tests."
147         echo "    --no-verify    Turn off verification (on by default)."
148         echo "    --no-optimize  Turn off optimization (on by default)."
149         echo "    --zygote       Spawn the process from the Zygote." \
150             "If used, then the"
151         echo "                   other runtime options are ignored."
152         echo "    --local        Use a host-local virtual machine."
153         echo "    --valgrind     Use valgrind when running locally."
154         echo "    --reference    Use a host-local reference virtual machine."
155     ) 1>&2
156     exit 1
157 fi
158
159 cd "$test_dir"
160 test_dir=`pwd`
161
162 td_info="${test_dir}/${info}"
163 td_expected="${test_dir}/${expected}"
164
165 tmp_dir="/tmp/test-$$"
166
167 if [ '!' '(' -r "$td_info" -a -r "$td_expected" ')' ]; then
168     echo "${test_dir}: missing files" 1>&2
169     exit 1
170 fi
171
172 # copy the test to a temp dir and run it
173
174 echo "${test_dir}: running..." 1>&2
175
176 rm -rf "$tmp_dir"
177 cp -Rp "$test_dir" "$tmp_dir"
178 cd "$tmp_dir"
179
180 if [ '!' -r "$build" ]; then
181     cp "${progdir}/etc/default-build" build
182 fi
183
184 if [ '!' -r "$run" ]; then
185     cp "${progdir}/etc/default-run" run
186 fi
187
188 chmod 755 "$build"
189 chmod 755 "$run"
190
191 good="no"
192 if [ "$dev_mode" = "yes" ]; then
193     "./${build}" 2>&1
194     echo "build exit status: $?" 1>&2
195     "./${run}" $run_args "$@" 2>&1
196     echo "run exit status: $?" 1>&2
197     good="yes"
198 elif [ "$update_mode" = "yes" ]; then
199     "./${build}" >"$build_output" 2>&1
200     build_exit="$?"
201     if [ "$build_exit" = '0' ]; then
202         "./${run}" $run_args "$@" >"$output" 2>&1
203         sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
204         good="yes"
205     else
206         cat "$build_output" 1>&2
207         echo "build exit status: $build_exit" 1>&2
208     fi
209 else
210     "./${build}" >"$build_output" 2>&1
211     build_exit="$?"
212     if [ "$build_exit" = '0' ]; then
213         "./${run}" $run_args "$@" >"$output" 2>&1
214     else
215         cp "$build_output" "$output"
216         echo "build exit status: $build_exit" >>"$output"
217     fi
218     diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
219     if [ "$?" = "0" ]; then
220         # output == expected
221         good="yes"
222         echo "${test_dir}: succeeded!" 1>&2
223     fi
224 fi
225
226 if [ "$good" = "yes" ]; then
227     cd "$oldwd"
228     rm -rf "$tmp_dir"
229     exit 0
230 fi
231
232 (
233     if [ "$update_mode" '!=' "yes" ]; then
234         echo "${test_dir}: FAILED!"
235         echo ' '
236         echo '#################### info'
237         cat "${td_info}" | sed 's/^/# /g'
238         echo '#################### diffs'
239         diff --strip-trailing-cr -u "$expected" "$output"
240         echo '####################'
241         echo ' '
242     fi
243     echo "files left in ${tmp_dir}"
244 ) 1>&2
245
246 exit 1